unit Utils;

interface

function BytesToStr(source: string): string;
function StrToBytes(source: string): string;

function GUIDToStr(source: TGUID): string;
function StrToGUID(source: string): TGUID;

implementation

function BytesToStr(source: string): string;
var
  i: integer;
  p: PChar;
  ps: PChar;
const
  hexdigits: array [0..$f] of char = '0123456789ABCDEF';
begin
  SetLength(Result, Length(source)*2);
  p:= PChar(Result);
  ps:= PChar(source);
  for i:= 0 to Length(source)-1 do begin
    p^:= hexdigits[(byte(ps^) and $f0) shr 4];
    inc(p);
    p^:= hexdigits[byte(ps^) and $0f];
    inc(p);
    inc(ps);
  end;
end;


function CharHex(const C: char): Byte;
const
  DecDigits = ['0'..'9'];
  HexDigits = ['0'..'9', 'A'..'F', 'a'..'f'];
begin
  Result:= $FF;
  if C in DecDigits then
    Result:= Ord(UpCase(C)) - Ord('0')
  else
  begin
    if C in HexDigits then
      Result:= Ord(UpCase(C)) - Ord('A') + 10;
  end;
end;

function StrToBytes(source: string): string;
var
  C: cardinal;
  P: PChar;
  PD: PChar;
  BL, BH: Byte;
  S: string;
  size: cardinal;
begin
  size:= (Length(source)+1) div 2;
  SetLength(Result, size);
  PD:= PChar(Result);
  FillChar(PD^, size, 0);
  S:= source;

  if Odd(Length(S)) then S:= '0' + S;
  P:= PChar(S);
  C:= 0;
  while C < size do begin
    BH:= CharHex(P^); Inc(P);
    BL:= CharHex(P^); Inc(P);
    Inc(C);
    if (BH = $FF) or (BL = $FF) then Exit;
    PD^:= char((BH shl 4) + BL);
    inc(PD);
  end;
end;

function GUIDToStr(source: TGUID): string;
var
  s: string;
begin
  SetLength(s, sizeof(TGUID));
  Move(source, PChar(s)^, sizeof(TGUID));
  Result:= BytesToStr(s);
end;

function StrToGUID(source: string): TGUID;
var
  s: string;
begin
  s:= StrToBytes(source);
  Move(PChar(s)^, Result, sizeof(Result));
end;

end.
